/***********************************************************************
This program code generates the empirical rejection rates of C(a) and 
    BJ test when asymptotic null cv's are applied.
***********************************************************************/


new;
library pgraph;

nnn = 500;                                                      /* # of observations */
kkk = 3000;                                                     /* # of interations */

p1  = 0.5;
q1  = p1;
pp  = (1-q1)/(2-p1-q1);
tm1 = 1;
tm2 = 2;

sdd = 0.0;

al1 = -1*sdd;  be1 = 0.5;  sts1 = 1.;
al2 = 1*sdd;  be2 = 0.5;  sts2 = sts1;

qqq = zeros(kkk,11);

jjj = 1;
do until jjj > kkk;

    /* dgp */ 
    sss = zeros(nnn,1);
    rrr = zeros(nnn,1);
    xxx = zeros(nnn,1);
 
    sss = rndu(nnn,1);
    if sss[1,1] < pp; rrr[1,1] = -1; else; rrr[1,1] = 1; endif;
    iii = 2;
    do until iii > nnn;
        if rrr[iii-1,1] == tm1;
            if sss[iii,1] < p1;
                rrr[iii,1] = tm1;
            else;
                rrr[iii,1] = tm2;
            endif;
            else;
            if sss[iii,1] < q1;
                rrr[iii,1] = tm2;
            else;
                rrr[iii,1] = tm1;
            endif;
        endif;
        iii = iii + 1;
    endo;

    aaa = sts1*rndn(nnn,1);
    bbb = sts2*rndn(nnn,1);

    xxx[1,1] = rndn(1,1);
    iii = 2;
    do until iii > nnn;
	    if rrr[iii,1] == tm1;
		    xxx[iii,1] = al1+ be1*xxx[iii-1,1] + aaa[iii,1];
	    else;
		    xxx[iii,1] = al2+ be2*xxx[iii-1,1] + bbb[iii,1];
	    endif;
	    iii = iii + 1;
    endo;

    ind = ones(nnn-1,1)~xxx[1:nnn-1,1];
    dep = xxx[2:nnn,1];

    beh = inv(ind'*ind)*ind'*dep;
    ehe = dep - ind*beh;

    mn = meanc(ehe);
    sd = sqrt(sumc((ehe-mn)^2)/(nnn-1));

    kur = sumc((ehe-mn).^4)/((nnn-1)*sd^4);
    ske = sumc((ehe-mn).^3)/(sd^3*(nnn-1));

    jbt = nnn*(ske^2/6 + (kur-3)^2/24);

    xwe = zeros(2,1);
    ywe = zeros(2,1);
    xwe[1,1] = kur-3;
    mss = minc(xwe)^2/24;
    ywe[1,1] = mss;
    ywe[2,1] = ske^2/6;

    cal = nnn*maxc(ywe);
    qqq[jjj,1] = jjj/kkk;
    qqq[jjj,2] = jbt;
    qqq[jjj,3] = cal;

    jjj = jjj + 1;
endo;

jb2p5 = (qqq[.,2] .> cdfchii(0.975,2)); 
jb5p0 = (qqq[.,2] .> cdfchii(0.950,2)); 
jb7p5 = (qqq[.,2] .> cdfchii(0.925,2)); 
jb10p0 = (qqq[.,2] .> cdfchii(0.90,2)); 

ca10p0 = (qqq[.,3] .> 3.324525); 
ca7p5 = (qqq[.,3] .> 3.811150); 
ca5p0 = (qqq[.,3] .> 4.508150); 
ca2p5 = (qqq[.,3] .> 5.720925); 

print nnn;
print "J-B test";
print "2.5%" meanc(jb2p5);                                      /* Empirical rejection rate at 2.5% level of significance */
print "5.0%" meanc(jb5p0);                                      /* Empirical rejection rate at 5.0% level of significance */
print "7.5%" meanc(jb7p5);                                      /* Empirical rejection rate at 7.5% level of significance */
print "10.%" meanc(jb10p0);                                     /* Empirical rejection rate at 10.% level of significance */

print "Calp test";
print "2.5%" meanc(ca2p5);                                      /* Empirical rejection rate at 2.5% level of significance */
print "5.0%" meanc(ca5p0);                                      /* Empirical rejection rate at 5.0% level of significance */
print "7.5%" meanc(ca7p5);                                      /* Empirical rejection rate at 7.5% level of significance */
print "10.%" meanc(ca10p0);                                     /* Empirical rejection rate at 10.% level of significance */    

col1_jb = qqq[.,1:2];
col1_ca = qqq[.,1]~qqq[.,3];
col1_jb[.,2] = sortc(col1_jb[.,2],1);
col1_ca[.,2] = sortc(col1_ca[.,2],1);

output file = table2_jb_4th_pn.txt reset;                         /* output file name for BJ test */
screen off;
print col1_jb;
screen on;
output off;

output file = table2_ca_4th_pn.txt reset;                          /* output file name for C(a) test */
screen off;
print col1_ca;
screen on;
output off;
