/***********************************************************************
This program code summarizes the empirical rejection rates of C(a) test 
    when asymptotic null cv's are applied.

Also, empirical null distribution based cv's are provided. 
***********************************************************************/
new;
library pgraph;

load table2_jb_1st_pn[3000,2] = table2_jb_1st_pn.txt;
load table2_jb_2nd_pn[3000,2] = table2_jb_2nd_pn.txt;
load table2_jb_3rd_pn[3000,2] = table2_jb_3rd_pn.txt;
load table2_jb_4th_pn[3000,2] = table2_jb_4th_pn.txt;
load table2_jb_4th_pn_300k[300000,2] = table2_jb_4th_pn(300k).txt;


te2_1st_10p0 = (table2_jb_1st_pn[.,2] .> cdfchii(0.90,2));
te2_2nd_10p0 = (table2_jb_2nd_pn[.,2] .> cdfchii(0.90,2));
te2_3rd_10p0 = (table2_jb_3rd_pn[.,2] .> cdfchii(0.90,2));
te2_4th_10p0 = (table2_jb_4th_pn[.,2] .> cdfchii(0.90,2));
te2_4th_s_10p0 = (table2_jb_4th_pn_300k[.,2] .> cdfchii(0.90,2));

te2_1st_7p5 = (table2_jb_1st_pn[.,2] .> cdfchii(0.9250,2));
te2_2nd_7p5 = (table2_jb_2nd_pn[.,2] .> cdfchii(0.9250,2));
te2_3rd_7p5 = (table2_jb_3rd_pn[.,2] .> cdfchii(0.9250,2));
te2_4th_7p5 = (table2_jb_4th_pn[.,2] .> cdfchii(0.9250,2));
te2_4th_s_7p5 = (table2_jb_4th_pn_300k[.,2] .> cdfchii(0.9250,2));

te2_1st_5p0 = (table2_jb_1st_pn[.,2] .> cdfchii(0.950,2));
te2_2nd_5p0 = (table2_jb_2nd_pn[.,2] .> cdfchii(0.950,2));
te2_3rd_5p0 = (table2_jb_3rd_pn[.,2] .> cdfchii(0.950,2));
te2_4th_5p0 = (table2_jb_4th_pn[.,2] .> cdfchii(0.950,2));
te2_4th_s_5p0 = (table2_jb_4th_pn_300k[.,2] .> cdfchii(0.950,2));

te2_1st_2p5 = (table2_jb_1st_pn[.,2] .> cdfchii(0.975,2));
te2_2nd_2p5 = (table2_jb_2nd_pn[.,2] .> cdfchii(0.975,2));
te2_3rd_2p5 = (table2_jb_3rd_pn[.,2] .> cdfchii(0.975,2));
te2_4th_2p5 = (table2_jb_4th_pn[.,2] .> cdfchii(0.975,2));
te2_4th_s_2p5 = (table2_jb_4th_pn_300k[.,2] .> cdfchii(0.975,2));

print meanc(te2_1st_10p0)~meanc(te2_1st_7p5)~meanc(te2_1st_5p0)~meanc(te2_1st_2p5);
print meanc(te2_2nd_10p0)~meanc(te2_2nd_7p5)~meanc(te2_2nd_5p0)~meanc(te2_2nd_2p5);
print meanc(te2_3rd_10p0)~meanc(te2_3rd_7p5)~meanc(te2_3rd_5p0)~meanc(te2_3rd_2p5);
print meanc(te2_4th_10p0)~meanc(te2_4th_7p5)~meanc(te2_4th_5p0)~meanc(te2_4th_2p5);
print meanc(te2_4th_s_10p0)~meanc(te2_4th_s_7p5)~meanc(te2_4th_s_5p0)~meanc(te2_4th_s_2p5);

m10p0 = 3000*0.900;
m07p5 = 3000*0.925;
m05p0 = 3000*0.950;
m02p5 = 3000*0.975;

k10p0 = 300000*0.900;
k07p5 = 300000*0.925;
k05p0 = 300000*0.950;
k02p5 = 300000*0.975;

print "size distortion adjusted critical values";
print table2_jb_4th_pn[m10p0,2]~table2_jb_4th_pn[m07p5,2]~table2_jb_4th_pn[m05p0,2]~table2_jb_4th_pn[m02p5,2];
/*
print table2_jb_4th_pn_300k[k10p0,2]~table2_jb_4th_pn_300k[k07p5,2]~table2_jb_4th_pn_300k[k05p0,2]~table2_jb_4th_pn_300k[k02p5,2];
*/